* [LTP] [Patch 2/10]Makefile patch to integrate to LTP
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
@ 2009-06-30 14:57 ` Poornima Nayak
2009-06-30 16:10 ` Subrata Modak
2009-06-30 14:57 ` [LTP] [Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test Poornima Nayak
` (8 subsequent siblings)
9 siblings, 1 reply; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:57 UTC (permalink / raw)
To: ltp-list
[Patch 2/10]Makefile patch to integrate to LTP
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/utils/benchmark/Makefile ltp_patched/utils/benchmark/Makefile
--- ltp_orig/utils/benchmark/Makefile 2009-06-30 15:04:20.000000000 +0530
+++ ltp_patched/utils/benchmark/Makefile 2009-06-30 15:12:52.000000000 +0530
@@ -18,7 +18,7 @@
####
################################################################################
-SUBDIRS := ebizzy-0.3
+SUBDIRS := ebizzy-0.3 kernbench-0.42
configure:
@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
@@ -27,6 +27,6 @@ all: configure
@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
install:
-
+ @set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
clean:
@set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* Re: [LTP] [Patch 2/10]Makefile patch to integrate to LTP
2009-06-30 14:57 ` [LTP] [Patch 2/10]Makefile patch to integrate to LTP Poornima Nayak
@ 2009-06-30 16:10 ` Subrata Modak
0 siblings, 0 replies; 14+ messages in thread
From: Subrata Modak @ 2009-06-30 16:10 UTC (permalink / raw)
To: Poornima Nayak; +Cc: ltp-list
On Tue, 2009-06-30 at 20:27 +0530, Poornima Nayak wrote:
> [Patch 2/10]Makefile patch to integrate to LTP
>
> Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
Checked in.
>
> diff -uprN ltp_orig/utils/benchmark/Makefile ltp_patched/utils/benchmark/Makefile
> --- ltp_orig/utils/benchmark/Makefile 2009-06-30 15:04:20.000000000 +0530
> +++ ltp_patched/utils/benchmark/Makefile 2009-06-30 15:12:52.000000000 +0530
> @@ -18,7 +18,7 @@
> ####
> ################################################################################
>
> -SUBDIRS := ebizzy-0.3
> +SUBDIRS := ebizzy-0.3 kernbench-0.42
>
> configure:
> @set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
> @@ -27,6 +27,6 @@ all: configure
> @set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
>
> install:
> -
> + @set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
> clean:
> @set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i $@; done;
>
> ------------------------------------------------------------------------------
> _______________________________________________
> Ltp-list mailing list
> Ltp-list@lists.sourceforge.net
> https://lists.sourceforge.net/lists/listinfo/ltp-list
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread
* [LTP] [Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
2009-06-30 14:57 ` [LTP] [Patch 2/10]Makefile patch to integrate to LTP Poornima Nayak
@ 2009-06-30 14:57 ` Poornima Nayak
2009-06-30 16:10 ` Subrata Modak
2009-06-30 14:57 ` [LTP] [Patch 4/10]Reusable functions for consolidation test modified Poornima Nayak
` (7 subsequent siblings)
9 siblings, 1 reply; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:57 UTC (permalink / raw)
To: ltp-list
[Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/README ltp_patched/testcases/kernel/power_management/README
--- ltp_orig/testcases/kernel/power_management/README 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/README 2009-06-30 16:31:17.000000000 +0530
@@ -80,3 +80,5 @@ Then either configuration is not set or
For CPU consolidation verification ebizzy is included in utils directory of LTP.
To run cpu consolidation test user has to provide -w <workload> -l <sched_mc_level>.
Refer to README in LTPROOT/utils/benchmark/ebizzy-0.2 directory for details of ebizzy.
+
+To test CPU consolidation for sched_mc 2 kernbench has to run. Kernbench needs linux kernel source as input in /root directory . For example download from http://www.kernel.org/pub/linux/kernel/v2.6/linux-2.6.29.4.tar.bz2. If Linux kernel source not found kernbench wiil not execute.
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* Re: [LTP] [Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test
2009-06-30 14:57 ` [LTP] [Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test Poornima Nayak
@ 2009-06-30 16:10 ` Subrata Modak
0 siblings, 0 replies; 14+ messages in thread
From: Subrata Modak @ 2009-06-30 16:10 UTC (permalink / raw)
To: Poornima Nayak; +Cc: ltp-list
On Tue, 2009-06-30 at 20:27 +0530, Poornima Nayak wrote:
> [Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test
>
> Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
Thanks.
>
> diff -uprN ltp_orig/testcases/kernel/power_management/README ltp_patched/testcases/kernel/power_management/README
> --- ltp_orig/testcases/kernel/power_management/README 2009-06-30 15:04:19.000000000 +0530
> +++ ltp_patched/testcases/kernel/power_management/README 2009-06-30 16:31:17.000000000 +0530
> @@ -80,3 +80,5 @@ Then either configuration is not set or
> For CPU consolidation verification ebizzy is included in utils directory of LTP.
> To run cpu consolidation test user has to provide -w <workload> -l <sched_mc_level>.
> Refer to README in LTPROOT/utils/benchmark/ebizzy-0.2 directory for details of ebizzy.
> +
> +To test CPU consolidation for sched_mc 2 kernbench has to run. Kernbench needs linux kernel source as input in /root directory . For example download from http://www.kernel.org/pub/linux/kernel/v2.6/linux-2.6.29.4.tar.bz2. If Linux kernel source not found kernbench wiil not execute.
>
> ------------------------------------------------------------------------------
> _______________________________________________
> Ltp-list mailing list
> Ltp-list@lists.sourceforge.net
> https://lists.sourceforge.net/lists/listinfo/ltp-list
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread
* [LTP] [Patch 4/10]Reusable functions for consolidation test modified
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
2009-06-30 14:57 ` [LTP] [Patch 2/10]Makefile patch to integrate to LTP Poornima Nayak
2009-06-30 14:57 ` [LTP] [Patch 3/10]Readme modified with pre-requisite for sched_mc=2 test Poornima Nayak
@ 2009-06-30 14:57 ` Poornima Nayak
2009-06-30 14:57 ` [LTP] [Patch 5/10]CPU consolidation testcase updated to handle exceptions Poornima Nayak
` (6 subsequent siblings)
9 siblings, 0 replies; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:57 UTC (permalink / raw)
To: ltp-list
[Patch 4/10]Reusable functions for consolidation test modified
This patch has fixes for sched_domian test failures in kernel version beyond 2.6.29.
Addtional new reusable functions and fixes for validation functions.
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/lib/sched_mc.py ltp_patched/testcases/kernel/power_management/lib/sched_mc.py
--- ltp_orig/testcases/kernel/power_management/lib/sched_mc.py 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/lib/sched_mc.py 2009-06-30 15:14:37.000000000 +0530
@@ -4,15 +4,19 @@
import os
import sys
+import re
+from time import time
__author__ = "Vaidyanathan Srinivasan <svaidy@linux.vnet.ibm.com>"
__author__ = "Poornima Nayak <mpnayak@linux.vnet.ibm.com>"
+
cpu_map = {}
stats_start = {}
stats_stop = {}
stats_percentage = {}
cpu_count = 0
+socket_count = 0
def clear_dmesg():
'''
@@ -24,30 +28,59 @@ def clear_dmesg():
print 'Clearing dmesg failed', e
sys.exit(1)
-def get_proc_data(stats_list):
- ''' Read /proc/stat info and store in dictionary
+def count_num_cpu():
+ ''' Returns number of cpu's in system
'''
try:
- file_procstat = open("/proc/stat", 'r')
- for line in file_procstat:
- if line.startswith('cpu'):
- data = line.split()
- stats_list[data[0]] = data
- file_procstat.close()
- except OSError, e:
- print "Could not read statistics", e
+ cpuinfo = open('/proc/cpuinfo', 'r')
+ global cpu_count
+ for line in cpuinfo:
+ if line.startswith('processor'):
+ cpu_count += 1
+ cpuinfo.close()
+ except IOError, e:
+ print "Could not get cpu count", e
+ sys.exit(1)
+
+def count_num_sockets():
+ ''' Returns number of cpu's in system
+ '''
+ socket_list = []
+ global socket_count
+ try:
+ for i in range(0, cpu_count):
+ phy_pkg_file = '/sys/devices/system/cpu/cpu%s' % i
+ phy_pkg_file += '/topology/physical_package_id'
+ socket_id = open(phy_pkg_file).read().rstrip()
+ if socket_id not in socket_list:
+ socket_list.append(socket_id)
+ socket_count = socket_count + 1
+ except Exception, details:
+ print "INFO: Failed to get number of sockets in system", details
+ sys.exit(1)
+
+def is_multi_socket():
+ '''Return 1 if the system is multi socket else return 0
+ '''
+ try:
+ if socket_count > 1:
+ return 1
+ else:
+ return 0
+ except Exception:
+ print "Failed to check if system is multi socket system"
sys.exit(1)
def is_hyper_threaded():
- '''Return 1 is the system is hyper threaded else return 0
+ '''Return 1 if the system is hyper threaded else return 0
'''
try:
file_cpuinfo = open("/proc/cpuinfo", 'r')
for line in file_cpuinfo:
if line.startswith('siblings'):
- siblings = line.split(":")
+ siblings = line.split(":")
if line.startswith('cpu cores'):
- cpu_cores = line.split(":")
+ cpu_cores = line.split(":")
break
if int( siblings[1] ) / int( cpu_cores[1] )> 1:
file_cpuinfo.close()
@@ -58,42 +91,24 @@ def is_hyper_threaded():
print "Failed to check if system is hyper-threaded"
sys.exit(1)
-def set_sched_mc_power(sched_mc_level):
- ''' Routine to set sched_mc_power_savings to required level
- '''
- try:
- os.system('echo %s > \
- /sys/devices/system/cpu/sched_mc_power_savings'
- % sched_mc_level)
- except OSError, e:
- print "Could not set sched_mc_power_savings to", e
- sys.exit(1)
-
-def set_sched_smt_power(sched_smt_level):
- ''' Routine to set sched_smt_power_savings to required level
- '''
- try:
- os.system('echo %s > \
- /sys/devices/system/cpu/sched_smt_power_savings'
- % sched_smt_level)
- except OSError, e:
- print "Could not set sched_smt_power_savings to", e
- sys.exit(1)
-
-def count_num_cpu():
- ''' Returns number of cpu's in system
+def get_hyper_thread_count():
+ ''' Return number of threads in CPU. For eg for x3950 this function
+ would return 2. In future if 4 threads are supported in CPU, this
+ routine would return 4
'''
try:
- cpuinfo = open('/proc/cpuinfo', 'r')
- global cpu_count
- for line in cpuinfo:
- if line.startswith('processor'):
- cpu_count += 1
- cpuinfo.close()
- except IOError, e:
- print "Could not get cpu count", e
+ file_cpuinfo = open("/proc/cpuinfo", 'r')
+ for line in file_cpuinfo:
+ if line.startswith('siblings'):
+ siblings = line.split(":")
+ if line.startswith('cpu cores'):
+ cpu_cores = line.split(":")
+ break
+ return( int( siblings[1] ) / int( cpu_cores[1] ) )
+ except Exception:
+ print "Failed to check if system is hyper-threaded"
sys.exit(1)
-
+
def map_cpuid_pkgid():
''' Routine to map physical package id to cpu id
'''
@@ -114,7 +129,7 @@ def map_cpuid_pkgid():
else:
core_info[core_id].append(i)
if not cpu_phy_id in cpu_map.keys():
- cpu_map[cpu_phy_id]= core_info
+ cpu_map[cpu_phy_id]= core_info
except Exception, details:
print "Package, core & cpu map table creation failed", e
sys.exit(1)
@@ -122,7 +137,7 @@ def map_cpuid_pkgid():
for i in range(0, cpu_count):
try:
phy_pkg_file = '/sys/devices/system/cpu/cpu%s' %i
- phy_pkg_file += '/topology/physical_package_id'
+ phy_pkg_file += '/topology/physical_package_id'
cpu_phy_id = open(phy_pkg_file).read().rstrip()
if not cpu_phy_id in cpu_map.keys():
cpu_map[cpu_phy_id] = [i]
@@ -132,86 +147,160 @@ def map_cpuid_pkgid():
print "Mapping of CPU to pkg id failed", e
sys.exit(1)
-def trigger_ebizzy (test_thread_consld):
+
+def get_proc_data(stats_list):
+ ''' Read /proc/stat info and store in dictionary
+ '''
+ try:
+ file_procstat = open("/proc/stat", 'r')
+ for line in file_procstat:
+ if line.startswith('cpu'):
+ data = line.split()
+ stats_list[data[0]] = data
+ file_procstat.close()
+ except OSError, e:
+ print "Could not read statistics", e
+ sys.exit(1)
+
+def set_sched_mc_power(sched_mc_level):
+ ''' Routine to set sched_mc_power_savings to required level
+ '''
+ try:
+ os.system('echo %s > \
+ /sys/devices/system/cpu/sched_mc_power_savings 2>/dev/null'
+ % sched_mc_level)
+ except OSError, e:
+ print "Could not set sched_mc_power_savings to", sched_mc_level, e
+ sys.exit(1)
+
+def set_sched_smt_power(sched_smt_level):
+ ''' Routine to set sched_smt_power_savings to required level
+ '''
+ try:
+ os.system('echo %s > \
+ /sys/devices/system/cpu/sched_smt_power_savings 2>/dev/null'
+ % sched_smt_level)
+ except OSError, e:
+ print "Could not set sched_smt_power_savings to", sched_smt_level, e
+ sys.exit(1)
+
+def trigger_ebizzy (stress, duration, background):
''' Triggers ebizzy workload for sched_mc=1
testing
'''
- if test_thread_consld != 0:
- threads = 2
- else:
- threads = cpu_count / len(cpu_map)
-
- duration = 60 # let the test run for 1 minute
- olddir = os.getcwd()
- path = '%s/utils/benchmark' % os.environ['LTPROOT']
- os.chdir(path)
- wklds_avlbl = list()
- workload = "ebizzy"
- workload_dir = ""
+ try:
+ if stress == "thread":
+ threads = get_hyper_thread_count()
+ if stress == "partial":
+ threads = cpu_count / socket_count
+ if stress == "full":
+ threads = cpu_count
+
+ olddir = os.getcwd()
+ path = '%s/utils/benchmark' % os.environ['LTPROOT']
+ os.chdir(path)
+ wklds_avlbl = list()
+ workload = "ebizzy"
+ workload_dir = ""
- # Use the latest version of similar workload available
- for file_name in os.listdir('.'):
- if file_name.find(workload) != -1:
- wklds_avlbl.append(file_name)
-
- wklds_avlbl.sort()
- workload_dir = wklds_avlbl[len(wklds_avlbl)-1]
- if workload_dir != "":
- new_path = os.path.join(path,"%s" % workload_dir)
- get_proc_data(stats_start)
- try:
- os.chdir(new_path)
- os.system('./ebizzy -t%s -s4096 -S %s >/dev/null'
- % (threads, duration))
- print "INFO: ebizzy workload triggerd"
- os.chdir(olddir)
- get_proc_data(stats_stop)
- except Exception, details:
- print "Ebizzy workload trigger failed ", details
- sys.exit(1)
+ # Use the latest version of similar workload available
+ for file_name in os.listdir('.'):
+ if file_name.find(workload) != -1:
+ wklds_avlbl.append(file_name)
+
+ wklds_avlbl.sort()
+ workload_dir = wklds_avlbl[len(wklds_avlbl)-1]
+ if workload_dir != "":
+ new_path = os.path.join(path,"%s" % workload_dir)
+ get_proc_data(stats_start)
+ try:
+ os.chdir(new_path)
+ if background == "yes":
+ succ = os.system('./ebizzy -t%s -s4096 -S %s >/dev/null &' % (threads, duration))
+ else:
+ succ = os.system('./ebizzy -t%s -s4096 -S %s >/dev/null' % (threads, duration))
+
+ if succ == 0:
+ print "INFO: ebizzy workload triggerd"
+ os.chdir(olddir)
+ get_proc_data(stats_stop)
+ else:
+ print "INFO: ebizzy workload triggerd failed"
+ os.chdir(olddir)
+ get_proc_data(stats_stop)
+ sys.exit(1)
+ except Exception, details:
+ print "Ebizzy workload trigger failed ", details
+ sys.exit(1)
+ except Exception, details:
+ print "Ebizzy workload trigger failed ", details
+ sys.exit(1)
-def trigger_mc2_workld (test_thread_consld):
+def trigger_kernbench (stress, background):
''' Trigger load on system like kernbench.
Copys existing copy of LTP into as LTP2 and then builds it
with make -j
'''
olddir = os.getcwd()
try:
- if test_thread_consld != 0:
- threads = 2
- else:
- threads = cpu_count / len(cpu_map)
- src_path = os.environ['LTPROOT']
- dst_path = src_path + '2'
- os.system ('cp -r %s/ %s/ >/dev/null' %(src_path, dst_path))
+ if stress == "thread":
+ threads = 2
+ if stress == "partial":
+ threads = cpu_count / socket_count
+ if stress == "full":
+ threads = cpu_count
+
+ dst_path = "/root"
+ olddir = os.getcwd()
+ path = '%s/utils/benchmark' % os.environ['LTPROOT']
+ os.chdir(path)
+ wklds_avlbl = list()
+ for file_name in os.listdir('.'):
+ if file_name.find("kernbench") != -1:
+ wklds_avlbl.append(file_name)
+ if len(wklds_avlbl):
+ wklds_avlbl.sort()
+ workload_dir = wklds_avlbl[len(wklds_avlbl)-1]
+ if workload_dir != "":
+ benchmark_path = os.path.join(path,"%s" % workload_dir)
+ else:
+ print "INFO: kernbench benchmark not found"
+ sys.exit(1)
+ os.chdir(olddir)
+
os.chdir(dst_path)
- os.system ( 'make clean >/dev/null')
+ linux_source_dir=""
+ for file_name in os.listdir('.'):
+ if file_name.find("linux-2.6") != -1 and os.path.isdir(file_name):
+ linux_source_dir=file_name
+ break
+ if linux_source_dir != "":
+ os.chdir(linux_source_dir)
+ else:
+ print "INFO: Linux kernel source not found. Kernbench cannot be executed"
+ sys.exit(1)
+
get_proc_data(stats_start)
- os.system('make -j %s >/dev/null 2>&1' % threads)
- print "INFO: Workload for sched_mc=2 triggerd"
+ os.system ( '%s/kernbench -o 2 -M -H -n 1 >/dev/null 2>&1' % benchmark_path)
+
+ print "INFO: Workload kernbench triggerd"
os.chdir(olddir)
- os.system ('rm -rf %s >/dev/null' % dst_path)
get_proc_data(stats_stop)
except Exception, details:
- print "Workload trigger using make -j failed ", details
+ print "Workload trigger kernbench failed ", details
sys.exit(1)
-def trigger_workld(sched_mc, test_thread_consld):
- ''' Based on sched_mc value invokes workload triggering function.
+def trigger_workld(workload, stress, duration, background):
+ ''' Triggers workload passed as argument. Number of threads
+ triggered is based on stress value.
'''
- if test_thread_consld != 0:
- threads = 2
- else:
- threads = cpu_count / len(cpu_map)
- duration = 60 # let the test run for 1 minute
- path = '%s/utils/benchmark' % os.environ['LTPROOT']
- try:
- if int (sched_mc) == 1:
- trigger_ebizzy (test_thread_consld)
- if int (sched_mc) == 2:
- trigger_mc2_workld (test_thread_consld)
+ try:
+ if workload == "ebizzy":
+ trigger_ebizzy (stress, duration, background)
+ if workload == "kernbench":
+ trigger_kernbench (stress, background)
except Exception, details:
- print "INFO: CPU consolidation failed", details
+ print "INFO: Trigger workload failed", details
sys.exit(1)
def generate_report():
@@ -297,15 +386,18 @@ def expand_range(range_val):
Expand the range of value into actual numbers
'''
ids_list = list()
- sep_comma = range_val.split(",")
- for i in range(0, len(sep_comma)):
- hyphen_values = sep_comma[i].split("-")
- if len(hyphen_values) == 1:
- ids_list.append(int(hyphen_values[0]))
- else:
- for j in range(int(hyphen_values[0]), int(hyphen_values[1])+1):
- ids_list.append(j)
- return(ids_list)
+ try:
+ sep_comma = range_val.split(",")
+ for i in range(0, len(sep_comma)):
+ hyphen_values = sep_comma[i].split("-")
+ if len(hyphen_values) == 1:
+ ids_list.append(int(hyphen_values[0]))
+ else:
+ for j in range(int(hyphen_values[0]), int(hyphen_values[1])+1):
+ ids_list.append(j)
+ return(ids_list)
+ except Exception, details:
+ print "INFO: expand_pkg_grps failed ", details
def is_quad_core():
'''
@@ -357,20 +449,17 @@ def validate_cpugrp_map(cpu_group, sched
print "INFO:CPUs utilized not in a core"
return 0
print "INFO: CPUs utilized is not in same package or core"
- sys.exit(1)
+ return(1)
else:
for pkg in sorted(cpu_map.keys()):
pkg_cpus = cpu_map[pkg]
if pkg_cpus == cpu_group:
return(0)
- else:
- if is_quad_core() and sched_mc_level == 0:
- return(0)
- print "INFO: CPUs utilized is not in same package"
- sys.exit(1)
+ return(1)
except Exception, details:
print "Exception in validate_cpugrp_map: ", details
sys.exit(1)
+
def verify_sched_domain_dmesg(sched_mc_level, sched_smt_level):
'''
@@ -378,20 +467,37 @@ def verify_sched_domain_dmesg(sched_mc_l
'''
cpu_group = list()
try:
- dmesg_info = os.popen('dmesg -c').read()
- lines = dmesg_info.split('\n')
- for i in range(0, len(lines)):
- if lines[i].endswith('CPU'):
- groups = lines[i+1].split("groups:")
- subgroup = groups[1].split()
- for j in range(0, len(subgroup)):
- cpu_group = expand_range(subgroup[j])
- validate_cpugrp_map(cpu_group, sched_mc_level,\
- sched_smt_level)
+ dmesg_info = os.popen('dmesg').read()
+ if dmesg_info != "":
+ lines = dmesg_info.split('\n')
+ for i in range(0, len(lines)):
+ if lines[i].endswith('CPU'):
+ groups = lines[i+1].split("groups:")
+ group_info = groups[1]
+ if group_info.find("(") != -1:
+ openindex=group_info.index("(")
+ closeindex=group_info.index(")")
+ group_info=group_info.replace(group_info[openindex:closeindex+1],"")
+
+ subgroup = group_info.split()
+ for j in range(0, len(subgroup)):
+ cpu_group = expand_range(subgroup[j])
+ status = validate_cpugrp_map(cpu_group, sched_mc_level,\
+ sched_smt_level)
+ if status == 1:
+ if is_quad_core() == 1:
+ if int(sched_mc_level) == 0:
+ return(0)
+ else:
+ return(1)
+ else:
+ return(1)
+ return(0)
+ else:
+ return(1)
except Exception, details:
print "Reading dmesg failed", details
sys.exit(1)
- return(0)
def validate_cpu_consolidation(sched_mc_level, sched_smt_level):
''' Verify if cpu's on which threads executed belong to same
@@ -400,15 +506,38 @@ def validate_cpu_consolidation(sched_mc_
cpus_utilized = list()
try:
for l in sorted(stats_percentage.keys()):
- if stats_percentage[l][1] > 20:
+ #modify threshold
+ if stats_percentage[l][1] > 50:
cpu_id = stats_percentage[l][0].split("cpu")
if cpu_id[1] != '':
cpus_utilized.append(int(cpu_id[1]))
cpus_utilized.sort()
print "INFO: CPU's utilized ", cpus_utilized
- validate_cpugrp_map(cpus_utilized, sched_mc_level, sched_smt_level)
+ status = validate_cpugrp_map(cpus_utilized, sched_mc_level, sched_smt_level)
+ if status == 1:
+ print "INFO: CPUs utilized is not in same package or core"
+ return(status)
except Exception, details:
print "Exception in validate_cpu_consolidation: ", details
sys.exit(1)
- return(0)
+
+def reset_schedmc():
+ ''' Routine to reset sched_mc_power_savings to Zero level
+ '''
+ try:
+ os.system('echo 0 > \
+ /sys/devices/system/cpu/sched_mc_power_savings 2>/dev/null')
+ except OSError, e:
+ print "Could not set sched_mc_power_savings to 0", e
+ sys.exit(1)
+
+def reset_schedsmt():
+ ''' Routine to reset sched_smt_power_savings to Zero level
+ '''
+ try:
+ os.system('echo 0 > \
+ /sys/devices/system/cpu/sched_smt_power_savings 2>/dev/null')
+ except OSError, e:
+ print "Could not set sched_smt_power_savings to 0", e
+ sys.exit(1)
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* [LTP] [Patch 5/10]CPU consolidation testcase updated to handle exceptions
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (2 preceding siblings ...)
2009-06-30 14:57 ` [LTP] [Patch 4/10]Reusable functions for consolidation test modified Poornima Nayak
@ 2009-06-30 14:57 ` Poornima Nayak
2009-06-30 14:57 ` [LTP] [Patch 6/10]sched domian " Poornima Nayak
` (5 subsequent siblings)
9 siblings, 0 replies; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:57 UTC (permalink / raw)
To: ltp-list
[Patch 5/10]CPU consolidation testcase updated to handle exceptions
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/cpu_consolidation.py ltp_patched/testcases/kernel/power_management/cpu_consolidation.py
--- ltp_orig/testcases/kernel/power_management/cpu_consolidation.py 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/cpu_consolidation.py 2009-06-30 15:21:42.000000000 +0530
@@ -12,42 +12,47 @@ from sched_mc import *
__author__ = "Poornima Nayak <mpnayak@linux.vnet.ibm.com>"
-# Run test based on the command line arguments
-if __name__ == "__main__":
+class Usage(Exception):
+ def __init__(self, msg):
+ self.msg = msg
+
+def main(argv=None):
+ if argv is None:
+ argv = sys.argv
+
usage = "-w"
parser = OptionParser(usage)
parser.add_option("-c", "--mc_level", dest="mc_level",
- help="Sched mc power saving value 0/1/2")
+ default=0, help="Sched mc power saving value 0/1/2")
parser.add_option("-t", "--smt_level", dest="smt_level",
default=0, help="Sched smt power saving value 0/1/2")
+ parser.add_option("-w", "--workload", dest="work_ld",
+ default="ebizzy", help="Workload can be ebizzy/kernbench")
+ parser.add_option("-s", "--stress", dest="stress",
+ default="partial", help="Load on system is full/partial [i.e 50%]/thread")
(options, args) = parser.parse_args()
- test_thread_consld = 0
-
try:
- set_sched_mc_power(options.mc_level)
count_num_cpu()
+ count_num_sockets()
+ if is_multi_socket():
+ set_sched_mc_power(options.mc_level)
+ if is_hyper_threaded():
+ set_sched_smt_power(options.smt_level)
map_cpuid_pkgid()
print "INFO: Created table mapping cpu to package"
-
- if int(options.smt_level) == 1 or int(options.smt_level) == 2 :
- if is_hyper_threaded():
- set_sched_smt_power(options.smt_level)
- # Trigger ebizzy with 2 threads only to verify logical CPU
- # consolidation
- test_thread_consld = 1
- trigger_workld(options.mc_level, test_thread_consld)
- generate_report()
- validate_cpu_consolidation(options.mc_level, options.smt_level)
- test_thread_consld = 0
- else:
- print "INFO: No Hyper-threading support in this machine"
- sys.exit(0)
-
- trigger_workld(options.mc_level, test_thread_consld)
+ background="no"
+ duration=60
+ trigger_workld(options.work_ld, options.stress, duration, background)
generate_report()
- validate_cpu_consolidation(options.mc_level, options.smt_level)
- sys.exit(0)
+ status = validate_cpu_consolidation(options.mc_level, options.smt_level)
+ reset_schedmc()
+ if is_hyper_threaded():
+ reset_schedsmt()
+ return(status)
except Exception, details:
- print "INFO(: CPU consolidation failed", details
- sys.exit(1)
+ print "INFO: CPU consolidation failed", details
+ return(1)
+
+if __name__ == "__main__":
+ sys.exit(main())
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* [LTP] [Patch 6/10]sched domian testcase updated to handle exceptions
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (3 preceding siblings ...)
2009-06-30 14:57 ` [LTP] [Patch 5/10]CPU consolidation testcase updated to handle exceptions Poornima Nayak
@ 2009-06-30 14:57 ` Poornima Nayak
2009-06-30 14:58 ` [LTP] [Patch 7/10]Fixes for sched_mc & sched_smt interface test Poornima Nayak
` (4 subsequent siblings)
9 siblings, 0 replies; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:57 UTC (permalink / raw)
To: ltp-list
[Patch 6/10]sched domian testcase updated to handle exceptions
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/sched_domain.py ltp_patched/testcases/kernel/power_management/sched_domain.py
--- ltp_orig/testcases/kernel/power_management/sched_domain.py 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/sched_domain.py 2009-06-30 15:22:38.000000000 +0530
@@ -12,18 +12,19 @@ from optparse import OptionParser
__author__ = "Poornima Nayak <mpnayak@linux.vnet.ibm.com>"
-# Run test based on the command line arguments
-if __name__ == "__main__":
- sched_smt = 0
- sched_mc = 0
+class Usage(Exception):
+ def __init__(self, msg):
+ self.msg = msg
+
+def main(argv=None):
+ if argv is None:
+ argv = sys.argv
usage = "-w"
parser = OptionParser(usage)
- parser.add_option("-w", "--workload", dest="workload",
- help="Test name that has be triggered")
- parser.add_option("-c", "--mc_level", dest="mc_level",
+ parser.add_option("-c", "--mc_level", dest="mc_level", default=-1,
help="Sched mc power saving value 0/1/2")
- parser.add_option("-t", "--smt_level", dest="smt_level", default=0,
+ parser.add_option("-t", "--smt_level", dest="smt_level", default=-1,
help="Sched smt power saving value 0/1/2")
(options, args) = parser.parse_args()
@@ -32,18 +33,24 @@ if __name__ == "__main__":
count_num_cpu()
map_cpuid_pkgid()
- if int(options.smt_level) == 1 or int(options.smt_level) == 2:
+ if is_hyper_threaded() and int(options.smt_level) >= 0:
+ set_sched_smt_power(options.smt_level)
+
+ if int(options.mc_level) >= 0:
+ set_sched_mc_power(options.mc_level)
+ if int(options.smt_level) >= 0 or int(options.mc_level) >= 0:
+ status = verify_sched_domain_dmesg(options.mc_level, options.smt_level)
+ reset_schedmc()
if is_hyper_threaded():
- sched_smt_level = options.smt_level
- set_sched_smt_power(sched_smt_level)
- else:
- print "INFO: No Hyper-threading support in this machine"
- sys.exit(0)
-
- # Validate sched domain for sched_mc = 1, sched_smt = 0
- set_sched_mc_power(options.mc_level)
- verify_sched_domain_dmesg(options.mc_level, options.smt_level)
- sys.exit(0)
+ reset_schedsmt()
+ return(status)
+ else:
+ print "INFO: Invalid arguments given"
+ return 1
except Exception, details:
print "INFO: sched domain test failed: ", details
- sys.exit(1)
+ return(1)
+
+# Run test based on the command line arguments
+if __name__ == "__main__":
+ sys.exit(main())
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* [LTP] [Patch 7/10]Fixes for sched_mc & sched_smt interface test
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (4 preceding siblings ...)
2009-06-30 14:57 ` [LTP] [Patch 6/10]sched domian " Poornima Nayak
@ 2009-06-30 14:58 ` Poornima Nayak
2009-06-30 14:58 ` [LTP] [Patch 8/10]New set of reusbale Library functions and fixes Poornima Nayak
` (3 subsequent siblings)
9 siblings, 0 replies; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:58 UTC (permalink / raw)
To: ltp-list
[Patch 7/10]Fixes for sched_mc & sched_smt interface test
Existing testcase in LTP would fail or not cover all possible sched_mc values.
This patch has been written to make testcase flexible to run on future releases.
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/test_sched_mc.sh ltp_patched/testcases/kernel/power_management/test_sched_mc.sh
--- ltp_orig/testcases/kernel/power_management/test_sched_mc.sh 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/test_sched_mc.sh 2009-06-30 16:09:06.000000000 +0530
@@ -2,8 +2,10 @@
. pm_include.sh
-valid_input="0 1 2"
-invalid_input="a abcefg x1999 xffff -1 -00000
+get_kernel_version
+get_valid_input $kernel_version
+
+invalid_input="3 4 5 6 7 8 a abcefg x1999 xffff -1 -00000
200000000000000000000000000000000000000000000000000000000000000000000000000000
ox324 -0xfffffffffffffffffffff"
test_file="/sys/devices/system/cpu/sched_mc_power_savings"
@@ -14,7 +16,7 @@ fi
RC=0
echo "${0}: ---Valid test cases---"
-check_input "${valid_input}" valid $test_file
+check_input "${valid_input}" valid $test_file
RC=$?
echo "${0}: ---Invalid test cases---"
check_input "${invalid_input}" invalid $test_file
diff -uprN ltp_orig/testcases/kernel/power_management/test_sched_smt.sh ltp_patched/testcases/kernel/power_management/test_sched_smt.sh
--- ltp_orig/testcases/kernel/power_management/test_sched_smt.sh 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/test_sched_smt.sh 2009-06-30 16:09:13.000000000 +0530
@@ -1,8 +1,11 @@
#!/bin/bash
. pm_include.sh
-valid_input="0 1"
-invalid_input="a abcefg x1999 xffff -1 -00000
+
+get_kernel_version
+get_valid_input $kernel_version
+
+invalid_input="3 4 5 6 7 8 a abcefg x1999 xffff -1 -00000
200000000000000000000000000000000000000000000000000000000000000000000000000000
ox324 -0xfffffffffffffffffffff"
test_file="/sys/devices/system/cpu/sched_smt_power_savings"
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* [LTP] [Patch 8/10]New set of reusbale Library functions and fixes
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (5 preceding siblings ...)
2009-06-30 14:58 ` [LTP] [Patch 7/10]Fixes for sched_mc & sched_smt interface test Poornima Nayak
@ 2009-06-30 14:58 ` Poornima Nayak
2009-06-30 14:58 ` [LTP] [Patch 9/10]Master script modified to cover additional test scenarios Poornima Nayak
` (2 subsequent siblings)
9 siblings, 0 replies; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:58 UTC (permalink / raw)
To: ltp-list
[Patch 8/10]New set of reusbale Library functions and fixes
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/pm_include.sh ltp_patched/testcases/kernel/power_management/pm_include.sh
--- ltp_orig/testcases/kernel/power_management/pm_include.sh 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/pm_include.sh 2009-06-30 16:06:32.000000000 +0530
@@ -7,6 +7,7 @@ FAIL=1
NOSUPPORT=2
MISSING_FILE=3
UNTESTED=4
+YES=0
function cleanup() {
if [ -f ${1} ] ; then
@@ -65,9 +66,9 @@ function is_hyper_threaded() {
siblings=`cat /proc/cpuinfo | grep siblings | uniq | cut -f2 -d':'`
cpu_cores=`cat /proc/cpuinfo | grep "cpu cores" | uniq | cut -f2 -d':'`
if [ $siblings -eq $cpu_cores ]; then
- echo 0
+ return 1
else
- echo 1
+ return 0
fi
}
@@ -101,4 +102,291 @@ function check_input() {
done
return $RC
}
-
+
+function is_multi_socket() {
+ no_of_sockets=`cat /sys/devices/system/cpu/cpu?/topology/physical_package_id | uniq | wc -l`
+ if [ $no_of_sockets -gt 1 ] ; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+function get_kernel_version() {
+ # Get kernel minor version
+ export kernel_version=`uname -r | awk -F. '{print $1"."$2"."$3}' | cut -f1 -d'-'`
+}
+
+function get_valid_input() {
+ kernel_version=$1
+ case "$kernel_version" in
+ '2.6.29' | '2.6.30' | '2.6.31')
+ export valid_input="0 1 2" ;;
+ *) export valid_input="0 1" ;;
+ esac
+}
+
+function get_max_sched_mc() {
+ get_kernel_version
+ case "$kernel_version" in
+ '2.6.29' | '2.6.30' | '2.6.31')
+ return 2
+ ;;
+ '2.6.26' | '2.6.27' | '2.6.28')
+ return 1
+ ;;
+ *)
+ return 0
+ ;;
+ esac
+}
+
+function get_max_sched_smt() {
+ get_kernel_version
+ case "$kernel_version" in
+ '2.6.29' | '2.6.30' | '2.6.31')
+ return 2
+ ;;
+ '2.6.26' | '2.6.27' | '2.6.28')
+ return 1
+ ;;
+ *)
+ return 0
+ ;;
+ esac
+}
+
+function check_supp_wkld() {
+ sched_mcsmt=$1
+ work_load=$2
+
+ case "$sched_mcsmt" in
+ 1) if [ "$work_load" == "ebizzy" ]; then
+ return 0
+ else
+ return 1
+ fi
+ ;;
+ 2) if [ "$work_load" == "ebizzy" -o "$work_load" == "kernbench" ]; then
+ return 0
+ else
+ return 1
+ fi
+ ;;
+ *)
+ return 1
+ ;;
+ esac
+}
+
+function analyze_wrt_workload_hyperthreaded() {
+ sched_mc=$1
+ work_load=$2
+ pass_count=$3
+ sched_smt=$4
+ stress=$5
+
+ if [ $sched_mc > $sched_smt ]; then
+ check_supp_wkld $sched_mc $work_load; valid_workload=$?
+ else
+ check_supp_wkld $sched_smt $work_load; valid_workload=$?
+ fi
+
+ if [ "$stress" = "thread" ]; then
+ case "$valid_workload" in
+ 0)
+ if [ $pass_count -lt 5 ]; then
+ RC=1
+ tst_resm TFAIL "Consolidation at core level failed for \
+sched_mc=$sched_mc, sched_smt=$sched_smt for workload=$work_load"
+ else
+ tst_resm TPASS "Consolidation at core level passed for \
+sched_mc=$sched_mc, sched_smt=$sched_smt & workload=$work_load"
+ fi ;;
+ 1)
+ if [ $pass_count -lt 5 ]; then
+ tst_resm TPASS "Consolidation at core level failed for \
+unsupported workload $work_load when sched_mc=$sched_mc & sched_smt=$sched_smt"
+ else
+ RC=1
+ tst_resm TFAIL "Consolidation at core level passed for \
+unsupported workload $work_load when sched_mc=$sched_mc & sched_smt=$sched_smt"
+ fi ;;
+ esac
+ else
+ case "$valid_workload" in
+ 0)
+ if [ $pass_count -lt 5 ]; then
+ RC=1
+ tst_resm TFAIL "Consolidation at package level failed for \
+sched_mc=$sched_mc, sched_smt=$sched_smt for workload=$work_load"
+ else
+ tst_resm TPASS "Consolidation at package level passed for \
+sched_mc=$sched_mc, sched_smt=$sched_smt & workload=$work_load"
+ fi ;;
+ 1)
+ echo "pass count is $pass_count"
+ if [ $pass_count -lt 5 ]; then
+ tst_resm TPASS "Consolidation at package level failed for \
+unsupported workload $work_load when sched_mc=$sched_mc & sched_smt=$sched_smt"
+ else
+ RC=1
+ tst_resm TFAIL "Consolidation at package level passed for \
+unsupported workload $work_load when sched_mc=$sched_mc & sched_smt=$sched_smt"
+ fi ;;
+ esac
+ fi
+}
+
+function analyze_wrt_wkld() {
+ sched_mc=$1
+ work_load=$2
+ pass_count=$3
+ sched_smt=$4
+ stress=$5
+
+ check_supp_wkld $sched_mc $work_load; valid_workload=$?
+ if [ $hyper_threaded -eq $YES ]; then
+ analyze_wrt_workload_hyperthreaded $sched_mc $work_load $pass_count\
+ $sched_smt $stress
+ else
+ case "$valid_workload" in
+ 0)
+ if [ "$pass_count" -lt 5 ]; then
+ RC=1
+ tst_resm TFAIL "cpu consolidation failed for \
+sched_mc=$sched_mc for workload=$work_load"
+ else
+ tst_resm TPASS "cpu consolidation passed for \
+sched_mc=$sched_mc for workload=$work_load"
+ fi ;;
+ 1)
+ if [ "$pass_count" -lt 5 ]; then
+ tst_resm TPASS "cpu consolidation failed for \
+unsupported workload $work_load when sched_mc=$sched_mc"
+ else
+ RC=1
+ tst_resm TFAIL "cpu consolidation passed for \
+unsupported workload $work_load when sched_mc=$sched_mc"
+ fi ;;
+ esac
+ fi
+}
+
+function analyze_result_hyperthreaded() {
+ sched_mc=$1
+ work_load=$2
+ pass_count=$3
+ sched_smt=$4
+ stress=$5
+
+ case "$sched_mc" in
+ 0)
+ if [ $sched_smt ]; then
+ case "$sched_smt" in
+ 0)
+ if [ "$stress" = "thread" ]; then
+ if [ $pass_count -lt 1 ]; then
+ tst_resm TPASS "Consolidation at core level failed for sched_mc=\
+$sched_mc & sched_smt=$sched_smt for workload=$work_load"
+ else
+ RC=1
+ tst_resm TFAIL "Consolidation at core level passed for sched_mc=\
+$sched_mc & sched_smt=$sched_smt for workload=$work_load"
+ fi
+ else
+ if [ "$pass_count" -lt 1 ]; then
+ tst_resm TPASS "cpu consolidation failed for sched_mc=\
+$sched_mc & sched_smt=$sched_smt for workload=$work_load"
+ else
+ RC=1
+ tst_resm TFAIL "cpu consolidation passed for sched_mc=\
+$sched_mc & sched_smt=$sched_smt for workload=$work_load"
+ fi
+ fi
+ ;;
+ *)
+ if [ "$stress" = "thread" ]; then
+ analyze_wrt_wkld $sched_mc $work_load $pass_count $sched_smt $stress
+ else
+ analyze_wrt_wkld $sched_mc $work_load $pass_count $sched_smt
+ fi ;;
+ esac
+ else
+ if [ $pass_count -lt 1 ]; then
+ tst_resm TPASS "cpu consolidation failed for sched_mc=\
+$sched_mc for workload=$work_load"
+ else
+ RC=1
+ tst_resm TFAIL "cpu consolidation passed for sched_mc=\
+$sched_mc & sched_smt=$sched_smt for workload=$work_load"
+ fi
+ fi
+ ;;
+ *)
+ if [ "$stress" = "thread" ]; then
+ analyze_wrt_wkld $sched_mc $work_load $pass_count $sched_smt $stress
+ else
+ analyze_wrt_wkld $sched_mc $work_load $pass_count $sched_smt
+ fi
+ ;;
+ esac
+}
+
+function analyze_consolidation_result() {
+ sched_mc=$1
+ work_load=$2
+ pass_count=$3
+ sched_smt=$4
+ stress=$5
+
+ if [ $hyper_threaded -eq $YES ]; then
+ analyze_result_hyperthreaded $sched_mc $work_load $pass_count $sched_smt $stress
+ else
+ case "$sched_mc" in
+ 0)
+ if [ $pass_count -lt 1 ]; then
+ tst_resm TPASS "cpu consolidation failed for sched_mc=\
+$sched_mc for workload=$work_load"
+ else
+ RC=1
+ tst_resm TFAIL "cpu consolidation passed for sched_mc=\
+$sched_mc for workload=$work_load"
+ fi ;;
+ *)
+ analyze_wrt_wkld $sched_mc $work_load $pass_count
+ ;;
+ esac
+ fi
+}
+
+function analyze_sched_domain_result(){
+ sched_mc=$1
+ result=$2
+ sched_smt=$3
+
+ if [ $hyper_threaded -eq $YES ]; then
+ if [ $sched_smt ]; then
+ if [ "$result" = 0 ];then
+ tst_resm TPASS "sched domain test for sched_mc=$sched_mc & sched_smt=$sched_smt"
+ else
+ RC=1
+ tst_resm TFAIL "sched domain test sched_mc=$sched_mc & sched_smt=$sched_smt"
+ fi
+ else
+ if [ "$result" = 0 ];then
+ tst_resm TPASS "sched domain test for sched_mc=$sched_mc"
+ else
+ RC=1
+ tst_resm TFAIL "sched domain test for sched_mc=$sched_mc"
+ fi
+ fi
+ else
+ if [ "$result" = 0 ];then
+ tst_resm TPASS "sched domain test for sched_mc=$sched_mc"
+ else
+ RC=1
+ tst_resm TFAIL "sched domain test sched_mc=$sched_mc"
+ fi
+ fi
+}
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* [LTP] [Patch 9/10]Master script modified to cover additional test scenarios
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (6 preceding siblings ...)
2009-06-30 14:58 ` [LTP] [Patch 8/10]New set of reusbale Library functions and fixes Poornima Nayak
@ 2009-06-30 14:58 ` Poornima Nayak
2009-06-30 14:58 ` [LTP] [Patch 10/10]Patch to add another command file in runtest Poornima Nayak
2009-06-30 16:09 ` [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Subrata Modak
9 siblings, 0 replies; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:58 UTC (permalink / raw)
To: ltp-list
[Patch 9/10]Master script modified to cover additional test scenarios
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/testcases/kernel/power_management/runpwtests.sh ltp_patched/testcases/kernel/power_management/runpwtests.sh
--- ltp_orig/testcases/kernel/power_management/runpwtests.sh 2009-06-30 15:04:19.000000000 +0530
+++ ltp_patched/testcases/kernel/power_management/runpwtests.sh 2009-06-30 16:15:18.000000000 +0530
@@ -30,15 +30,18 @@
#
# Exporting Required variables
-
+echo Are we really executing this ?
export TST_TOTAL=1
-LTPTMP=${TMP}
+#LTPTMP=${TMP}
export PATH=${PATH}:.
-export TCID="Power Management"
+export TCID="Power_Management"
export TST_COUNT=0
+export contacts="mpnayak@linux.vnet.ibm.com"
+export analysis="/proctstat"
+YES=0
#List of reusable functions defined in pm_include.sh
-. pm_include.sh
+. ./pm_include.sh
# Function: main
#
@@ -50,158 +53,172 @@ export TST_COUNT=0
RC=0 #Return status
# Checking required kernel version and architecture
-check_kv_arch; RC=$?
+check_kv_arch
+RC=$?
if [ $RC -eq 1 ] ; then
- tst_resm TCONF "Kernel version or Architecture not supported:\
-Not running testcases"
+ tst_resm TCONF "Kernel version or Architecture not supported: Not running testcases"
exit 0
fi
-# Checking sched_mc sysfs interface
+is_hyper_threaded; hyper_threaded=$?
+
+#Checking sched_mc sysfs interface
#check_config.sh config_sched_mc || RC=$?
+TST_COUNT=1
if [ -f /sys/devices/system/cpu/sched_mc_power_savings ] ; then
if test_sched_mc.sh ; then
- tst_resm TPASS "SCHED_MC sysfs tests passed"
+ tst_resm TPASS "SCHED_MC sysfs tests"
else
RC=$?
- tst_resm TFAIL "SCHED_MC sysfs tests failed"
+ tst_resm TFAIL "SCHED_MC sysfs tests"
fi
- # Test CPU consolidation for corresponding sched_mc
- which python > /dev/null
- if [ $? -ne 0 ] ; then
- tst_resm TCONF "Python is not installed, CPU Consoldation\
- test not run"
- else
- # Test CPU consolidation on hyper-threaded system
- hyper_threaded=$(is_hyper_threaded)
- if [ $hyper_threaded -eq 1 ]; then
- for sched_mc in `seq 0 2`; do
- for sched_smt in `seq 0 1`; do
- if [ $sched_smt -eq 0 -a $sched_mc -eq 0 ]; then
- continue
- fi
- if cpu_consolidation.py -c $sched_mc -t $sched_smt ; then
- tst_resm TPASS "cpu consolidation sched_mc=$sched_mc,\
- sched_smt=$sched_smt"
- else
- RC=$?
- tst_resm TFAIL "cpu consolidation \
- sched_mc=$sched_mc, sched_smt=$sched_smt"
- fi
- done
- done
- else
- # Test CPU consolidation for sched_mc=1 & 2
- for sched_mc in `seq 1 2`; do
- if cpu_consolidation.py -c $sched_mc ; then
- tst_resm TPASS "cpu consolidation test for \
-sched_mc_power set to $sched_mc"
- else
- RC=$?
- tst_resm TFAIL "cpu consolidation test\
- sched_mc_power set to $sched_mc"
- fi
- done
- fi
+else
+ tst_resm TCONF "Required kernel configuration for SCHED_MC NOT set"
+fi
- # Testcase to validate sched_domain tree
- if [ $hyper_threaded -eq 1 ]; then
- for sched_mc in `seq 0 2`; do
- for sched_smt in `seq 0 1`; do
- if [ $sched_smt -eq 0 -a $sched_mc -eq 0 ]; then
- continue
- fi
-
- if sched_domain.py -c $sched_mc -t $sched_smt; then
- tst_resm TPASS "sched domain test sched_mc=$sched_mc,\
-sched_smt=$sched_smt "
- else
- RC=$?
- tst_resm TFAIL "sched domain test sched_mc=$sched_mc,\
-sched_smt=$sched_smt "
- fi
- done
- done
- else
- # Validate CPU level sched domain topology validation
- for sched_mc in `seq 1 2`; do
- if sched_domain.py -c $sched_mc ; then
- tst_resm TPASS "sched domain test for sched_mc=$sched_mc "
- else
- RC=$?
- tst_resm TFAIL "sched domain test for sched_mc=$sched_mc "
- fi
- done
-
- fi
- fi
+# Test sched_smt_power_savings interface on HT machines
+((TST_COUNT= $TST_COUNT + 1))
+if [ -f /sys/devices/system/cpu/sched_smt_power_savings ] ; then
+ if test_sched_smt.sh; then
+ tst_resm TPASS "SCHED_SMT sysfs test"
+ else
+ RC=$?
+ tst_resm TFAIL "SCHED_SMT sysfs test"
+ fi
else
- tst_resm TCONF "Required kernel configuration for SCHED_MC NOT set"
+ if [ $hyper_threaded -eq $YES ]; then
+ RC=$?
+ tst_resm TFAIL "Required kernel configuration for SCHED_SMT NOT set"
+ else
+ tst_resm TCONF "Required Hyper Threading support for SCHED_SMT test"
+ fi
fi
+
# Checking cpufreq sysfs interface files
#check_config.sh config_cpu_freq || RC=$?
+((TST_COUNT= $TST_COUNT + 1))
if [ -d /sys/devices/system/cpu/cpu0/cpufreq ] ; then
- if check_cpufreq_sysfs_files.sh ; then
- tst_resm TPASS "CPUFREQ sysfs tests "
+ if check_cpufreq_sysfs_files.sh; then
+ tst_resm TPASS "CPUFREQ sysfs tests"
else
RC=$?
tst_resm TFAIL "CPUFREQ sysfs tests "
fi
- # Changing governors
- if change_govr.sh ; then
+ # Changing governors
+ ((TST_COUNT= $TST_COUNT + 1))
+ if change_govr.sh; then
tst_resm TPASS "Changing governors "
else
RC=$?
tst_resm TFAIL "Changing governors "
fi
- # Changing frequencies
- if change_freq.sh ; then
+ # Changing frequencies
+ ((TST_COUNT= $TST_COUNT + 1))
+ if change_freq.sh ; then
tst_resm TPASS "Changing frequncies "
else
RC=$?
- tst_resm TFAIL "Changing frequncies "
- fi
+ tst_resm TFAIL "Changing frequncies "
+ fi
- # Loading and Unloading governor related kernel modules
- if pwkm_load_unload.sh ; then
+ # Loading and Unloading governor related kernel modules
+ ((TST_COUNT= $TST_COUNT + 1))
+ if pwkm_load_unload.sh ; then
tst_resm TPASS "Loading and Unloading of governor kernel \
- modules got failed"
+modules"
else
RC=$?
- tst_resm TFAIL "Loading and Unloading of governor kernel \
- modules got failed"
- fi
+ tst_resm TFAIL "Loading and Unloading of governor kernel \
+ modules got failed"
+ fi
else
- tst_resm TCONF "Required kernel configuration for CPU_FREQ NOT set"
+ tst_resm TCONF "Required kernel configuration for CPU_FREQ NOT set"
fi
# Checking cpuidle sysfs interface files
+(( TST_COUNT= $TST_COUNT +1))
if check_cpuidle_sysfs_files.sh ; then
- tst_resm TPASS "CPUIDLE sysfs tests failed"
+ tst_resm TPASS "CPUIDLE sysfs tests passed"
else
RC=$?
- tst_resm TFAIL "CPUIDLE sysfs tests failed"
+ tst_resm TFAIL "CPUIDLE sysfs tests failed"
fi
-# Test sched_smt_power_savings interface on HT machines
-if [ -f /sys/devices/system/cpu/sched_smt_power_savings ] ; then
- if test_sched_smt.sh ; then
- tst_resm TPASS "SCHED_MC sysfs tests failed"
- else
- RC=$?
- tst_resm TFAIL "SCHED_MC sysfs tests failed"
- fi
+# sched_domain test
+which python > /dev/null
+if [ $? -ne 0 ] ; then
+ tst_resm TCONF "Python is not installed, CPU Consoldation\
+test cannot run"
else
- hyper_threaded=$(is_hyper_threaded)
- if [ $hyper_threaded -eq 1 ]; then
- tst_resm TFAIL "Required kernel configuration for SCHED_SMT NOT set"
- RC=1
+ get_max_sched_mc; max_sched_mc=$?
+ for sched_mc in `seq 0 $max_sched_mc`; do
+ (( TST_COUNT= $TST_COUNT +1))
+ sched_domain.py -c $sched_mc; RC=$?
+ analyze_sched_domain_result $sched_mc $RC
+ if [ $hyper_threaded -eq $YES ]; then
+ get_max_sched_smt ; max_sched_smt=$?
+ for sched_smt in `seq 0 $max_sched_smt`; do
+ # Testcase to validate sched_domain tree
+ (( TST_COUNT= $TST_COUNT +1))
+ sched_domain.py -c $sched_mc -t $sched_smt; RC=$?
+ analyze_sched_domain_result $sched_mc $RC $sched_smt ;
+ done
+ fi
+ done
+fi
+if [ $# -gt 0 -a $1 == "-exclusive" ]; then
+ # Test CPU consolidation
+ which python > /dev/null
+ if [ $? -ne 0 ] ; then
+ tst_resm TCONF "Python is not installed, CPU Consoldation\
+ test not run"
else
- tst_resm TCONF "Required Hyper Threading support in the\
-system under test"
+ sched_mc_smt_pass_cnt=0
+ work_loads_list="ebizzy kernbench"
+ for sched_mc in `seq 0 $max_sched_mc`; do
+ for work_load in ${work_loads_list}
+ do
+ ((TST_COUNT= $TST_COUNT + 1))
+ sched_mc_pass_cnt=0
+ for repeat_test in `seq 1 10`; do
+ #Testcase to validate CPU consolidation for sched_mc
+ if cpu_consolidation.py -c $sched_mc -w $work_load ; then
+ ((sched_mc_pass_cnt= $sched_mc_pass_cnt +1))
+ fi
+ done
+ analyze_consolidation_result $sched_mc $work_load $sched_mc_pass_cnt
+ done
+ if [ $hyper_threaded -eq $YES ]; then
+ for sched_smt in `seq 0 $max_sched_smt`; do
+ for work_load in ${work_loads_list}; do
+ ((TST_COUNT= $TST_COUNT + 1))
+ sched_mc_smt_pass_cnt=0
+ for repeat_test in `seq 1 10`; do
+ # Testcase to validate CPU consolidation for
+ # for sched_mc & sched_smt with stress=50%
+ if cpu_consolidation.py -c $sched_mc -t $sched_smt -w $work_load; then
+ ((sched_mc_smt_pass_cnt= $sched_mc_smt_pass_cnt +1))
+ fi
+ done
+ analyze_consolidation_result $sched_mc $work_load $sched_mc_smt_pass_cnt $sched_smt
+
+ #Testcase to validate consolidation at core level
+ sched_mc_smt_pass_cnt=0
+ stress="thread"
+ ((TST_COUNT= $TST_COUNT + 1))
+ for repeat_test in `seq 1 10`; do
+ if cpu_consolidation.py -c $sched_mc -t $sched_smt -w $work_load -s $stress; then
+ ((sched_mc_smt_pass_cnt= $sched_mc_smt_pass_cnt +1))
+ fi
+ done
+ analyze_consolidation_result $sched_mc $work_load $sched_mc_smt_pass_cnt $sched_smt $stress
+ done
+ done
+ fi
+ done
fi
fi
-exit $RC
\ No newline at end of file
+exit $RC
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* [LTP] [Patch 10/10]Patch to add another command file in runtest
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (7 preceding siblings ...)
2009-06-30 14:58 ` [LTP] [Patch 9/10]Master script modified to cover additional test scenarios Poornima Nayak
@ 2009-06-30 14:58 ` Poornima Nayak
2009-06-30 16:10 ` Subrata Modak
2009-06-30 16:09 ` [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Subrata Modak
9 siblings, 1 reply; 14+ messages in thread
From: Poornima Nayak @ 2009-06-30 14:58 UTC (permalink / raw)
To: ltp-list
[Patch 10/10]Patch to add another command file in runtest
Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
diff -uprN ltp_orig/runtest/power_management_tests_exclusive ltp_patched/runtest/power_management_tests_exclusive
--- ltp_orig/runtest/power_management_tests_exclusive 1970-01-01 05:30:00.000000000 +0530
+++ ltp_patched/runtest/power_management_tests_exclusive 2009-06-30 16:25:28.000000000 +0530
@@ -0,0 +1 @@
+POWER_MANAGEMENT runpwtests.sh -exclusive
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread* Re: [LTP] [Patch 10/10]Patch to add another command file in runtest
2009-06-30 14:58 ` [LTP] [Patch 10/10]Patch to add another command file in runtest Poornima Nayak
@ 2009-06-30 16:10 ` Subrata Modak
0 siblings, 0 replies; 14+ messages in thread
From: Subrata Modak @ 2009-06-30 16:10 UTC (permalink / raw)
To: Poornima Nayak; +Cc: ltp-list
On Tue, 2009-06-30 at 20:28 +0530, Poornima Nayak wrote:
> [Patch 10/10]Patch to add another command file in runtest
>
> Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
The last one also done.
Regards--
Subrata
>
> diff -uprN ltp_orig/runtest/power_management_tests_exclusive ltp_patched/runtest/power_management_tests_exclusive
> --- ltp_orig/runtest/power_management_tests_exclusive 1970-01-01 05:30:00.000000000 +0530
> +++ ltp_patched/runtest/power_management_tests_exclusive 2009-06-30 16:25:28.000000000 +0530
> @@ -0,0 +1 @@
> +POWER_MANAGEMENT runpwtests.sh -exclusive
>
> ------------------------------------------------------------------------------
> _______________________________________________
> Ltp-list mailing list
> Ltp-list@lists.sourceforge.net
> https://lists.sourceforge.net/lists/listinfo/ltp-list
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread
* Re: [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2
2009-06-30 14:57 [LTP] [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2 Poornima Nayak
` (8 preceding siblings ...)
2009-06-30 14:58 ` [LTP] [Patch 10/10]Patch to add another command file in runtest Poornima Nayak
@ 2009-06-30 16:09 ` Subrata Modak
9 siblings, 0 replies; 14+ messages in thread
From: Subrata Modak @ 2009-06-30 16:09 UTC (permalink / raw)
To: Poornima Nayak; +Cc: ltp-list
On Tue, 2009-06-30 at 20:27 +0530, Poornima Nayak wrote:
> [Patch 1/10]Patch to integrate kernbench to LTP to test sched_mc=2
> To verify CPU consolidation when sched_mc=2 we need kernbench. Hence integrating it
> in LTP.
>
> Signed-off-by: poornima nayak <mpnayak@linux.vnet.ibm.com>
Thanks.
>
> diff -uprN ltp_orig/utils/benchmark/kernbench-0.42/COPYING ltp_patched/utils/benchmark/kernbench-0.42/COPYING
> --- ltp_orig/utils/benchmark/kernbench-0.42/COPYING 1970-01-01 05:30:00.000000000 +0530
> +++ ltp_patched/utils/benchmark/kernbench-0.42/COPYING 2009-06-30 15:05:39.000000000 +0530
> @@ -0,0 +1,340 @@
> + GNU GENERAL PUBLIC LICENSE
> + Version 2, June 1991
> +
> + Copyright (C) 1989, 1991 Free Software Foundation, Inc.
> + 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
> + Everyone is permitted to copy and distribute verbatim copies
> + of this license document, but changing it is not allowed.
> +
> + Preamble
> +
> + The licenses for most software are designed to take away your
> +freedom to share and change it. By contrast, the GNU General Public
> +License is intended to guarantee your freedom to share and change free
> +software--to make sure the software is free for all its users. This
> +General Public License applies to most of the Free Software
> +Foundation's software and to any other program whose authors commit to
> +using it. (Some other Free Software Foundation software is covered by
> +the GNU Library General Public License instead.) You can apply it to
> +your programs, too.
> +
> + When we speak of free software, we are referring to freedom, not
> +price. Our General Public Licenses are designed to make sure that you
> +have the freedom to distribute copies of free software (and charge for
> +this service if you wish), that you receive source code or can get it
> +if you want it, that you can change the software or use pieces of it
> +in new free programs; and that you know you can do these things.
> +
> + To protect your rights, we need to make restrictions that forbid
> +anyone to deny you these rights or to ask you to surrender the rights.
> +These restrictions translate to certain responsibilities for you if you
> +distribute copies of the software, or if you modify it.
> +
> + For example, if you distribute copies of such a program, whether
> +gratis or for a fee, you must give the recipients all the rights that
> +you have. You must make sure that they, too, receive or can get the
> +source code. And you must show them these terms so they know their
> +rights.
> +
> + We protect your rights with two steps: (1) copyright the software, and
> +(2) offer you this license which gives you legal permission to copy,
> +distribute and/or modify the software.
> +
> + Also, for each author's protection and ours, we want to make certain
> +that everyone understands that there is no warranty for this free
> +software. If the software is modified by someone else and passed on, we
> +want its recipients to know that what they have is not the original, so
> +that any problems introduced by others will not reflect on the original
> +authors' reputations.
> +
> + Finally, any free program is threatened constantly by software
> +patents. We wish to avoid the danger that redistributors of a free
> +program will individually obtain patent licenses, in effect making the
> +program proprietary. To prevent this, we have made it clear that any
> +patent must be licensed for everyone's free use or not licensed at all.
> +
> + The precise terms and conditions for copying, distribution and
> +modification follow.
> +\f
> + GNU GENERAL PUBLIC LICENSE
> + TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
> +
> + 0. This License applies to any program or other work which contains
> +a notice placed by the copyright holder saying it may be distributed
> +under the terms of this General Public License. The "Program", below,
> +refers to any such program or work, and a "work based on the Program"
> +means either the Program or any derivative work under copyright law:
> +that is to say, a work containing the Program or a portion of it,
> +either verbatim or with modifications and/or translated into another
> +language. (Hereinafter, translation is included without limitation in
> +the term "modification".) Each licensee is addressed as "you".
> +
> +Activities other than copying, distribution and modification are not
> +covered by this License; they are outside its scope. The act of
> +running the Program is not restricted, and the output from the Program
> +is covered only if its contents constitute a work based on the
> +Program (independent of having been made by running the Program).
> +Whether that is true depends on what the Program does.
> +
> + 1. You may copy and distribute verbatim copies of the Program's
> +source code as you receive it, in any medium, provided that you
> +conspicuously and appropriately publish on each copy an appropriate
> +copyright notice and disclaimer of warranty; keep intact all the
> +notices that refer to this License and to the absence of any warranty;
> +and give any other recipients of the Program a copy of this License
> +along with the Program.
> +
> +You may charge a fee for the physical act of transferring a copy, and
> +you may at your option offer warranty protection in exchange for a fee.
> +
> + 2. You may modify your copy or copies of the Program or any portion
> +of it, thus forming a work based on the Program, and copy and
> +distribute such modifications or work under the terms of Section 1
> +above, provided that you also meet all of these conditions:
> +
> + a) You must cause the modified files to carry prominent notices
> + stating that you changed the files and the date of any change.
> +
> + b) You must cause any work that you distribute or publish, that in
> + whole or in part contains or is derived from the Program or any
> + part thereof, to be licensed as a whole at no charge to all third
> + parties under the terms of this License.
> +
> + c) If the modified program normally reads commands interactively
> + when run, you must cause it, when started running for such
> + interactive use in the most ordinary way, to print or display an
> + announcement including an appropriate copyright notice and a
> + notice that there is no warranty (or else, saying that you provide
> + a warranty) and that users may redistribute the program under
> + these conditions, and telling the user how to view a copy of this
> + License. (Exception: if the Program itself is interactive but
> + does not normally print such an announcement, your work based on
> + the Program is not required to print an announcement.)
> +\f
> +These requirements apply to the modified work as a whole. If
> +identifiable sections of that work are not derived from the Program,
> +and can be reasonably considered independent and separate works in
> +themselves, then this License, and its terms, do not apply to those
> +sections when you distribute them as separate works. But when you
> +distribute the same sections as part of a whole which is a work based
> +on the Program, the distribution of the whole must be on the terms of
> +this License, whose permissions for other licensees extend to the
> +entire whole, and thus to each and every part regardless of who wrote it.
> +
> +Thus, it is not the intent of this section to claim rights or contest
> +your rights to work written entirely by you; rather, the intent is to
> +exercise the right to control the distribution of derivative or
> +collective works based on the Program.
> +
> +In addition, mere aggregation of another work not based on the Program
> +with the Program (or with a work based on the Program) on a volume of
> +a storage or distribution medium does not bring the other work under
> +the scope of this License.
> +
> + 3. You may copy and distribute the Program (or a work based on it,
> +under Section 2) in object code or executable form under the terms of
> +Sections 1 and 2 above provided that you also do one of the following:
> +
> + a) Accompany it with the complete corresponding machine-readable
> + source code, which must be distributed under the terms of Sections
> + 1 and 2 above on a medium customarily used for software interchange; or,
> +
> + b) Accompany it with a written offer, valid for at least three
> + years, to give any third party, for a charge no more than your
> + cost of physically performing source distribution, a complete
> + machine-readable copy of the corresponding source code, to be
> + distributed under the terms of Sections 1 and 2 above on a medium
> + customarily used for software interchange; or,
> +
> + c) Accompany it with the information you received as to the offer
> + to distribute corresponding source code. (This alternative is
> + allowed only for noncommercial distribution and only if you
> + received the program in object code or executable form with such
> + an offer, in accord with Subsection b above.)
> +
> +The source code for a work means the preferred form of the work for
> +making modifications to it. For an executable work, complete source
> +code means all the source code for all modules it contains, plus any
> +associated interface definition files, plus the scripts used to
> +control compilation and installation of the executable. However, as a
> +special exception, the source code distributed need not include
> +anything that is normally distributed (in either source or binary
> +form) with the major components (compiler, kernel, and so on) of the
> +operating system on which the executable runs, unless that component
> +itself accompanies the executable.
> +
> +If distribution of executable or object code is made by offering
> +access to copy from a designated place, then offering equivalent
> +access to copy the source code from the same place counts as
> +distribution of the source code, even though third parties are not
> +compelled to copy the source along with the object code.
> +\f
> + 4. You may not copy, modify, sublicense, or distribute the Program
> +except as expressly provided under this License. Any attempt
> +otherwise to copy, modify, sublicense or distribute the Program is
> +void, and will automatically terminate your rights under this License.
> +However, parties who have received copies, or rights, from you under
> +this License will not have their licenses terminated so long as such
> +parties remain in full compliance.
> +
> + 5. You are not required to accept this License, since you have not
> +signed it. However, nothing else grants you permission to modify or
> +distribute the Program or its derivative works. These actions are
> +prohibited by law if you do not accept this License. Therefore, by
> +modifying or distributing the Program (or any work based on the
> +Program), you indicate your acceptance of this License to do so, and
> +all its terms and conditions for copying, distributing or modifying
> +the Program or works based on it.
> +
> + 6. Each time you redistribute the Program (or any work based on the
> +Program), the recipient automatically receives a license from the
> +original licensor to copy, distribute or modify the Program subject to
> +these terms and conditions. You may not impose any further
> +restrictions on the recipients' exercise of the rights granted herein.
> +You are not responsible for enforcing compliance by third parties to
> +this License.
> +
> + 7. If, as a consequence of a court judgment or allegation of patent
> +infringement or for any other reason (not limited to patent issues),
> +conditions are imposed on you (whether by court order, agreement or
> +otherwise) that contradict the conditions of this License, they do not
> +excuse you from the conditions of this License. If you cannot
> +distribute so as to satisfy simultaneously your obligations under this
> +License and any other pertinent obligations, then as a consequence you
> +may not distribute the Program at all. For example, if a patent
> +license would not permit royalty-free redistribution of the Program by
> +all those who receive copies directly or indirectly through you, then
> +the only way you could satisfy both it and this License would be to
> +refrain entirely from distribution of the Program.
> +
> +If any portion of this section is held invalid or unenforceable under
> +any particular circumstance, the balance of the section is intended to
> +apply and the section as a whole is intended to apply in other
> +circumstances.
> +
> +It is not the purpose of this section to induce you to infringe any
> +patents or other property right claims or to contest validity of any
> +such claims; this section has the sole purpose of protecting the
> +integrity of the free software distribution system, which is
> +implemented by public license practices. Many people have made
> +generous contributions to the wide range of software distributed
> +through that system in reliance on consistent application of that
> +system; it is up to the author/donor to decide if he or she is willing
> +to distribute software through any other system and a licensee cannot
> +impose that choice.
> +
> +This section is intended to make thoroughly clear what is believed to
> +be a consequence of the rest of this License.
> +\f
> + 8. If the distribution and/or use of the Program is restricted in
> +certain countries either by patents or by copyrighted interfaces, the
> +original copyright holder who places the Program under this License
> +may add an explicit geographical distribution limitation excluding
> +those countries, so that distribution is permitted only in or among
> +countries not thus excluded. In such case, this License incorporates
> +the limitation as if written in the body of this License.
> +
> + 9. The Free Software Foundation may publish revised and/or new versions
> +of the General Public License from time to time. Such new versions will
> +be similar in spirit to the present version, but may differ in detail to
> +address new problems or concerns.
> +
> +Each version is given a distinguishing version number. If the Program
> +specifies a version number of this License which applies to it and "any
> +later version", you have the option of following the terms and conditions
> +either of that version or of any later version published by the Free
> +Software Foundation. If the Program does not specify a version number of
> +this License, you may choose any version ever published by the Free Software
> +Foundation.
> +
> + 10. If you wish to incorporate parts of the Program into other free
> +programs whose distribution conditions are different, write to the author
> +to ask for permission. For software which is copyrighted by the Free
> +Software Foundation, write to the Free Software Foundation; we sometimes
> +make exceptions for this. Our decision will be guided by the two goals
> +of preserving the free status of all derivatives of our free software and
> +of promoting the sharing and reuse of software generally.
> +
> + NO WARRANTY
> +
> + 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
> +FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN
> +OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
> +PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
> +OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
> +MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS
> +TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE
> +PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
> +REPAIR OR CORRECTION.
> +
> + 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
> +WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
> +REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
> +INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
> +OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
> +TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
> +YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
> +PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
> +POSSIBILITY OF SUCH DAMAGES.
> +
> + END OF TERMS AND CONDITIONS
> +\f
> + How to Apply These Terms to Your New Programs
> +
> + If you develop a new program, and you want it to be of the greatest
> +possible use to the public, the best way to achieve this is to make it
> +free software which everyone can redistribute and change under these terms.
> +
> + To do so, attach the following notices to the program. It is safest
> +to attach them to the start of each source file to most effectively
> +convey the exclusion of warranty; and each file should have at least
> +the "copyright" line and a pointer to where the full notice is found.
> +
> + <one line to give the program's name and a brief idea of what it does.>
> + Copyright (C) <year> <name of author>
> +
> + This program is free software; you can redistribute it and/or modify
> + it under the terms of the GNU General Public License as published by
> + the Free Software Foundation; either version 2 of the License, or
> + (at your option) any later version.
> +
> + This program is distributed in the hope that it will be useful,
> + but WITHOUT ANY WARRANTY; without even the implied warranty of
> + MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
> + GNU General Public License for more details.
> +
> + You should have received a copy of the GNU General Public License
> + along with this program; if not, write to the Free Software
> + Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
> +
> +
> +Also add information on how to contact you by electronic and paper mail.
> +
> +If the program is interactive, make it output a short notice like this
> +when it starts in an interactive mode:
> +
> + Gnomovision version 69, Copyright (C) year name of author
> + Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
> + This is free software, and you are welcome to redistribute it
> + under certain conditions; type `show c' for details.
> +
> +The hypothetical commands `show w' and `show c' should show the appropriate
> +parts of the General Public License. Of course, the commands you use may
> +be called something other than `show w' and `show c'; they could even be
> +mouse-clicks or menu items--whatever suits your program.
> +
> +You should also get your employer (if you work as a programmer) or your
> +school, if any, to sign a "copyright disclaimer" for the program, if
> +necessary. Here is a sample; alter the names:
> +
> + Yoyodyne, Inc., hereby disclaims all copyright interest in the program
> + `Gnomovision' (which makes passes at compilers) written by James Hacker.
> +
> + <signature of Ty Coon>, 1 April 1989
> + Ty Coon, President of Vice
> +
> +This General Public License does not permit incorporating your program into
> +proprietary programs. If your program is a subroutine library, you may
> +consider it more useful to permit linking proprietary applications with the
> +library. If this is what you want to do, use the GNU Library General
> +Public License instead of this License.
> diff -uprN ltp_orig/utils/benchmark/kernbench-0.42/kernbench ltp_patched/utils/benchmark/kernbench-0.42/kernbench
> --- ltp_orig/utils/benchmark/kernbench-0.42/kernbench 1970-01-01 05:30:00.000000000 +0530
> +++ ltp_patched/utils/benchmark/kernbench-0.42/kernbench 2009-06-30 15:05:39.000000000 +0530
> @@ -0,0 +1,233 @@
> +#!/bin/sh
> +# kernbench by Con Kolivas <kernbench@kolivas.org>
> +# based on a benchmark by Martin J. Bligh
> +trap 'echo "ABORTING";exit' 1 2 15
> +
> +VERSION=0.42
> +
> +num_runs=5
> +single_runs=0
> +half_runs=1
> +opti_runs=1
> +max_runs=1
> +fast_run=0
> +
> +while getopts vsHOMn:o:hf i
> +do
> + case $i in
> + h) echo "kernbench v$VERSION by Con Kolivas <kernbench@kolivas.org>"
> + echo "Usage:"
> + echo "kernbench [-n runs] [-o jobs] [-s] [-H] [-O] [-M] [-h] [-v]"
> + echo "n : number of times to perform benchmark (default 5)"
> + echo "o : number of jobs for optimal run (default 4 * cpu)"
> + echo "s : perform single threaded runs (default don't)"
> + echo "H : don't perform half load runs (default do)"
> + echo "O : don't perform optimal load runs (default do)"
> + echo "M : don't perform maximal load runs (default do)"
> + echo "f : fast run"
> + echo "h : print this help"
> + echo "v : print version number"
> + exit ;;
> + v) echo "kernbench Version $VERSION by Con Kolivas <kernbench@kolivas.org>" ; exit ;;
> + n) nruns=$OPTARG ;;
> + o) optijobs=$OPTARG ;;
> + s) single_runs=1 ;;
> + H) half_runs=0 ;;
> + O) opti_runs=0 ;;
> + M) max_runs=0 ;;
> + f) fast_run=1 ;;
> + esac
> +done
> +
> +if [[ ! -f include/linux/kernel.h ]] ; then
> + echo "No kernel source found; exiting"
> + exit
> +fi
> +
> +for i in time awk yes date
> +do
> + iname=`which $i`
> + if [[ ! -a $iname ]] ; then
> + echo "$i not found in path, please install it; exiting"
> + exit
> + fi
> +done
> +
> +time=`which time`
> +
> +if [[ $nruns -gt 0 ]] ; then
> + num_runs=$nruns
> +elif [[ $fast_run -eq 1 ]]; then
> + echo "Dropping to 3 runs for fast run"
> + num_runs=3
> +fi
> +
> +if (($num_runs < 1)) ; then
> + echo "Nothing to do; exiting"
> + exit
> +fi
> +
> +if (($num_runs > 10)) ; then
> + echo "Are you crazy? trimming number of runs to 10"
> + num_runs=10
> +fi
> +
> +if [[ ! -d /proc ]] ; then
> + echo "Can't find proc filesystem; exiting"
> + exit
> +fi
> +
> +mem=`awk '/MemTotal/ {print $2}' /proc/meminfo`
> +if [[ $mem -lt 4000000 && $max_runs -gt 0 ]] ; then
> + echo Less than 4Gb ram detected!
> + echo Maximal loads will not measure cpu throughput and may cause a swapstorm!
> + echo If you did not plan this, -M flag is recommended to bypass maximal load.
> +fi
> +
> +(( single_runs *= $num_runs ))
> +(( half_runs *= $num_runs ))
> +(( opti_runs *= $num_runs ))
> +(( max_runs *= $num_runs ))
> +
> +cpus=`grep -c ^processor /proc/cpuinfo`
> +echo $cpus cpus found
> +echo Cleaning source tree...
> +make clean > /dev/null 2>&1
> +
> +if [[ $fast_run -eq 0 ]] ; then
> + echo Caching kernel source in ram...
> + for i in `find -type f`
> + do
> + cat $i > /dev/null
> + done
> +fi
> +
> +if [[ ! -f .config ]] ; then
> + echo No old config found, using defconfig
> + echo Making mrproper
> + make mrproper > /dev/null 2>&1
> + echo Making defconfig...
> + make defconfig > /dev/null 2>&1
> +else
> + echo Making oldconfig...
> + yes "" | make oldconfig > /dev/null 2>&1
> +fi
> +
> +halfjobs=$(( $cpus / 2 ))
> +optijobs=${optijobs:=$(( $cpus * 4 ))}
> +
> +if [[ $halfjobs -lt 2 ]] ; then
> + echo "Half load is no greater than single; disabling"
> + half_runs=0
> +elif [[ $halfjobs -eq 2 ]] ; then
> + echo "Half load is 2 jobs, changing to 3 as a kernel compile won't guarantee 2 jobs"
> + halfjobs=3
> +fi
> +
> +echo Kernel `uname -r`
> +echo Performing $num_runs runs of
> +if [[ $single_runs -gt 0 ]] ; then
> + echo make
> +fi
> +if [[ $half_runs -gt 0 ]] ; then
> + echo make -j $halfjobs
> +fi
> +if [[ $opti_runs -gt 0 ]] ; then
> + echo make -j $optijobs
> +fi
> +if [[ $max_runs -gt 0 ]] ; then
> + echo make -j
> +fi
> +echo
> +
> +echo All data logged to kernbench.log
> +
> +if [[ $fast_run -eq 0 ]] ; then
> + echo Warmup run...
> + make -j $optijobs > /dev/null 2>&1
> +fi
> +
> +date >> kernbench.log
> +uname -r >> kernbench.log
> +
> +add_data_point()
> +{
> + echo $@ | awk '{printf "%.6f %.6f %d", $1 + $2, $1 * $1 + $3, $4 + 1}'
> +}
> +
> +show_statistics()
> +{
> + case $3 in
> + 0)
> + echo "No data"
> + ;;
> + 1)
> + echo $1
> + ;;
> + *)
> + avg=`echo $1 $3 | awk '{print $1 / $2}'`
> + var=`echo $1 $2 $3 | awk '{print ($2 - ($1 * $1) / $3) / ($3 - 1)}'`
> + sdev=`echo $var | awk '{print $1^0.5}'`
> + echo "$avg ($sdev)"
> + ;;
> + esac
> +}
> +
> +do_log()
> +{
> + echo "Average $runname Run (std deviation):" > templog
> + echo Elapsed Time `show_statistics $temp_elapsed` >> templog
> + echo User Time `show_statistics $temp_user` >> templog
> + echo System Time `show_statistics $temp_sys` >> templog
> + echo Percent CPU `show_statistics $temp_percent` >> templog
> + echo Context Switches `show_statistics $temp_ctx` >> templog
> + echo Sleeps `show_statistics $temp_sleeps` >> templog
> + echo >> templog
> + cat templog
> + cat templog >> kernbench.log
> +}
> +
> +do_runs()
> +{
> + temp_elapsed="a"
> + for (( i=1 ; i <= temp_runs ; i++ ))
> + do
> + echo $runname run number $i...
> + make clean > /dev/null 2>&1
> + sync
> + if [[ $fast_run -eq 0 ]] ; then
> + sleep 5
> + fi
> + $time -f "%e %U %S %P %c %w" -o timelog make -j $tempjobs > /dev/null 2>&1
> + read elapsed_time user_time sys_time percent ctx sleeps <timelog
> + temp_elapsed=`add_data_point $elapsed_time $temp_elapsed`
> + temp_user=`add_data_point $user_time $temp_user`
> + temp_sys=`add_data_point $sys_time $temp_sys`
> + temp_percent=`add_data_point $percent $temp_percent`
> + temp_ctx=`add_data_point $ctx $temp_ctx`
> + temp_sleeps=`add_data_point $sleeps $temp_sleeps`
> + done
> + if [[ $temp_runs -ne 0 ]] ; then
> + do_log
> + fi
> +}
> +
> +temp_runs=$single_runs
> +tempjobs=1
> +runname="Single threaded"
> +do_runs
> +
> +temp_runs=$half_runs
> +tempjobs=$halfjobs
> +runname="Half load -j $halfjobs"
> +do_runs
> +
> +temp_runs=$opti_runs
> +tempjobs=$optijobs
> +runname="Optimal load -j $optijobs"
> +do_runs
> +
> +temp_runs=$max_runs
> +tempjobs=""
> +runname="Maximal load -j"
> +do_runs
> diff -uprN ltp_orig/utils/benchmark/kernbench-0.42/Makefile ltp_patched/utils/benchmark/kernbench-0.42/Makefile
> --- ltp_orig/utils/benchmark/kernbench-0.42/Makefile 1970-01-01 05:30:00.000000000 +0530
> +++ ltp_patched/utils/benchmark/kernbench-0.42/Makefile 2009-06-30 15:05:39.000000000 +0530
> @@ -0,0 +1,8 @@
> +all:
> +
> +install:
> + chmod ugo+x kernbench
> +
> +configure:
> +
> +clean:
> diff -uprN ltp_orig/utils/benchmark/kernbench-0.42/README ltp_patched/utils/benchmark/kernbench-0.42/README
> --- ltp_orig/utils/benchmark/kernbench-0.42/README 1970-01-01 05:30:00.000000000 +0530
> +++ ltp_patched/utils/benchmark/kernbench-0.42/README 2009-06-30 15:05:39.000000000 +0530
> @@ -0,0 +1,81 @@
> +Kernbench v0.42
> +
> +
> +What is this?
> +
> +This is a cpu throughput benchmark originally devised and used by Martin J.
> +Bligh. It is designed to compare kernels on the same machine, or to compare
> +hardware. To compare hardware you need to be running the same architecture
> +machines (eg i386), the same userspace binaries and run kernbench on the same
> +kernel source tree.
> +
> +It runs a kernel at various numbers of concurrent jobs: 1/2 number of cpus,
> +optimal (default is 4xnumber of cpus) and maximal job count. Optionally it can
> +also run single threaded. It then prints out a number of useful statistics
> +for the average of each group of runs and logs them to kernbench.log
> +
> +You need more than 2Gb of ram for this to be a true throughput benchmark or
> +else you will get swapstorms.
> +
> +Ideally it should be run in single user mode on a non-journalled filesystem.
> +To compare results it should always be run in the same kernel tree.
> +
> +
> +How do I use it?
> +
> +You need a kernel tree (any 2.6 will do) and the applications 'time', 'awk',
> +'date' and 'yes' installed. 'time' is different to the builtin time used by
> +BASH and has more information desired for this benchmark.
> +
> +Simply cd into the kernel tree directory and type
> +
> +/path/to/kernbench
> +
> +
> +Options
> +
> +kernbench [-n runs] [-o jobs] [-s] [-H] [-O] [-M] [-h] [-v]
> +n : number of times to perform benchmark (default 5)
> +o : number of jobs for optimal run (default 4 * cpu)
> +s : perform single threaded runs (default don't)
> +H : don't perform half load runs (default do)
> +O : don't perform optimal load runs (default do)
> +M : don't perform maximal load runs (default do)
> +f : fast run
> +h : print this help
> +v : print version number
> +
> +
> +Changelog:
> +v0.42 Fixed incorrect counting of cpus (thanks Flynn Marquardt)
> + Changed -j to at least 4GB ram.
> +
> +v0.41 Fixed make oldconfig
> +
> +v0.40 Made all runs use the oldconfig if it exists. Changed to only do one
> + warmup run before all the benchmarks. Added logging to kernbench.log
> + Cleaned up the code substantially to reuse code where possible.
> + Added standard deviation statistics courtesy of Peter Williams
> +
> +v0.30 Added fast run option which bypasses caching, warmup and tree
> + preparation and drops number of runs to 3. Modified half loads to
> + detect -j2 and change to -j3. Added syncs. Improved warnings and
> + messages.
> +
> +v0.20 Change to average of runs, add options to choose which runs to perform
> + remove single threaded run from defaults, do warmup run, lots more
> + sanity checks, drop meaningless runs, add a few warnings, remove fudge
> + factor from no. of jobs.
> +
> +v0.11 First public release
> +
> +
> +Thanks: M. Bligh for ideas. Others for help with magic incantations to get
> + BASH to work.
> +
> +
> +Con Kolivas <kernbench@kolivas.org>
> +Mon Jun 18 18:59:24 2007
> +
> +License:
> +GPL of course. Read COPYING included in this tarball.
>
> ------------------------------------------------------------------------------
> _______________________________________________
> Ltp-list mailing list
> Ltp-list@lists.sourceforge.net
> https://lists.sourceforge.net/lists/listinfo/ltp-list
------------------------------------------------------------------------------
_______________________________________________
Ltp-list mailing list
Ltp-list@lists.sourceforge.net
https://lists.sourceforge.net/lists/listinfo/ltp-list
^ permalink raw reply [flat|nested] 14+ messages in thread